#include<stdio.h>
#include<strings.h>
#include"floppy.h"

int from_disk(int drive) {
FILE *fd;
char *tbufr, *name;
int s,err=0;

	tbufr=(char *)malloc(8192);
	name=(char *)malloc(16);
	memset(name,0,16);

	sector_read(0,0,tbufr);
	hexdump(tbufr,1024);
	memcpy(name,tbufr,12);

	/* remove whitespaces */
	for(s=11;name[s]==0x20;s--) name[s]=0;
	while(name[0]==0x20) {
		for(s=0;s<strlen(name)-1;s++) name[s]=name[s+1];
	}
	
	if ( (fd=fopen(name,"w"))==NULL ) {
		printf("Can't open dump file.\n");
		free(tbufr);
		free(name);
		return -1;
	}
	
	for(s=0;s<1280;s+=8) {
		printf("Reading sectors %4d to %4d... ",s,s+7); fflush(stdout);
		if (m_sector_read(0,s,s+7,tbufr)<0) {
			printf("Read error.\n");
			err=-1;
		} else 
			printf("Ok.        ");
		printf("\r"); fflush(stdout);
		
		fwrite(tbufr,1,8192,fd);
	}
	fclose(fd);
	free(tbufr);
	free(name);
	
	if(err!=0) {
		printf("An error occured during disk read - dump file might be corrupted.\n");
		return -1;
	}
	
	return 0;
}

int to_disk(int drive, char *name) {
FILE *fd;
char *tbufr;
int s,err=0;

	tbufr=(char *)malloc(8192);

	if ( (fd=fopen(name,"r"))==NULL ) {
		printf("Can't open dump file.\n");
		free(tbufr);
		return -1;
	}
	
	for(s=0;s<1280;s+=8) {
		printf("Writing sectors %4d to %4d... ",s,s+7); fflush(stdout);
		fread(tbufr,1,8192,fd);
		if (m_sector_write(0,s,s+7,tbufr)<0) {
			printf("Write error.\n");
			err=-1;
		} else 
			printf("Ok.         ");
		printf("\r"); fflush(stdout);
	}
	printf("\n");
	fclose(fd);
	free(tbufr);
	
	if(err!=0) {
		printf("An error occured during disk write - disk might be corrupted.\n");
		return -1;
	}
	
	return 0;
}

void usage() {
	printf("\n\tfzdump - dump FZ-1 disks to/from dumpfile\n");
	printf("\t(c)2000 by Rainer Buchty (rainer@buchty.net)\n");
	printf("\n\tUsage: fzdump -if=infile [-of=outfile]\n\n");
	exit(-1);
}

int main(int argc, char **argv) {
int err=0;
char *fnamein=NULL, *fnameout=NULL;

	argc--; argv++;

        while(*argv!=NULL) {
		if (strncmp(*argv,"-if=",4)==0) {
			fnamein=(char *)malloc(strlen(*argv+4));
			strcpy(fnamein,*argv+4);
		}

		else if (strncmp(*argv,"-of=",4)==0) {
			fnameout=(char *)malloc(strlen(*argv+4));
			strcpy(fnameout,*argv+4);
		}

		else usage();

		argv++;
	}

	if ((fnamein==NULL)&&(fnameout==NULL))
		usage();

	if (strncmp(fnamein,"/dev/fd",7)==0)
		err=from_disk( (int)strtoul(fnamein+7,0,10));
		
	else if (strncmp(fnameout,"/dev/fd",7)==0)
		err=to_disk( (int)strtoul(fnameout+7,0,10), fnamein);

	else usage();
	
	free(fnamein);
	free(fnameout);

	exit(err);
}
	