#include<stdio.h>

static char *dump[]={
	"full\0",
	"bank\0",
	"voice\0",
	"effects\0"
};

typedef struct bank_data {
	short bstep;
	char bhwid[64];
	char blwid[64];
	char bhtch[64];
	char bltch[64];
	char bcent[64];
	char mchn[64];
	char gchn[64];
	char bvol[64];
	short vp[64];
	char name[14];
} bank_data_t;

typedef struct effect_data {
	char bend;
	char mvol;
	char suss;
	char mod_lfp;
	char mod_lfa;
	char mod_lff;
	char mod_lpq;
	char mod_dcf;
	char mod_dca;
	char mod_dcq;
	char fot_lpf;
	char fot_lfa;
	char fot_lff;
	char fot_lpq;
	char fot_dca;
	char fot_dcf;
	char fot_dcq;
	char aft_lfp;
	char aft_lfa;
	char aft_lff;
	char aft_lfq;
	char aft_dca;
	char aft_dcf;
	char aft_dcq;
} effect_data_t;

typedef struct voice_data {
	int wavst;
	int waved;
	int genst;
	int gened;
	short loop;
	char loop_sus;
	char loop_end;
	int loopst[8];
	int looped[8];
	short loopxf[8];
	short looptm[8];
	short dcp;
	char dcf;
	char dcq;
	char dca_sus;
	char dca_end;
	char dca_rate[8];
	char dca_stop[8];
	char dcf_sus;
	char dcf_end;
	char dcf_rate[8];
	char dcf_stop[8];
	short lfo_delay;
	char lfo_name;
	char lfo_atck;
	char lfo_rate;
	char lfo_dcp;
	char lfo_dca;
	char lfo_dcf;
	char lfo_dcq;
	char vel_dcq_kf;
	char dca_kf;
	char dca_rs;
	char dcf_kf;
	char dcf_rs;
	char vel_dca_kf;
	char vel_dca_rs;
	char vel_dcf_kf;
	char vel_dcf_rs;
	char vhwid;
	char vlwid;
	char vcent;
	char samp;
	char name[14];
} voice_data_t;


int i,j,offs;
int bnum,vnum,bcount,wcount,fsize,wmax,diff,pos;
unsigned char *buf, *outnam, ftype;
FILE *fd;
voice_data_t *voice;
bank_data_t *bank;

int main(int argc, char **argv) {
	argc--; argv++;
	
	if ( (fd=fopen(*argv,"r"))==NULL) {
		printf("Can't open \"%s\".\n",*argv);
		exit(-1);
	}
	
	fseek(fd,0,SEEK_END);
	fsize=ftell(fd);
	rewind(fd);
	
	buf=(char *)malloc(fsize);
	fread(buf,1,fsize,fd);	
	fclose(fd);
	
	ftype=buf[0x3e8+5];
	bnum=buf[0x3e8+7];
	vnum=buf[0x3e8+8];
	bcount=(buf[0x3e8+10]|(buf[0x3e8+11]<<8))&0xffff;
	wcount=(buf[0x3e8+12]|(buf[0x3e8+13]<<8))&0xffff;
	
	printf("\"%s\" is a %s dump file.\n",*argv,dump[ftype]);
	printf("\t# of banks:  %2d\n",bnum);
	printf("\t# of voices: %2d\n",vnum);
	printf("\tSize of PCM data: %4dkB\n",wcount&0xffff);
	printf("\tOverall size:     %4dkB\n",bcount&0xffff);
	
	bank=(bank_data_t *)malloc(sizeof(bank_data_t)*bnum);
	voice=(voice_data_t *)malloc(sizeof(voice_data_t)*vnum);

	/* read voice settings */
	for(i=0;i<vnum;i++) {
		offs=i*256+bnum*1024;
		strcpy(voice[i].name,buf+offs+0xb2);
		for(j=0;j<12;j++) if (voice[i].name[j]<0x20) voice[i].name[j]=0x20; else voice[i].name[j]=toupper(voice[i].name[j]);
		voice[i].wavst=buf[offs]     |(buf[offs+0x01]<<8)|(buf[offs+0x02]<<16)|(buf[offs+0x03]<<24);
		voice[i].waved=buf[offs+0x04]|(buf[offs+0x05]<<8)|(buf[offs+0x06]<<16)|(buf[offs+0x07]<<24);
		voice[i].genst=buf[offs+0x08]|(buf[offs+0x09]<<8)|(buf[offs+0x0a]<<16)|(buf[offs+0x0b]<<24);
		voice[i].gened=buf[offs+0x0c]|(buf[offs+0x0d]<<8)|(buf[offs+0x0e]<<16)|(buf[offs+0x0f]<<24);
		voice[i].loop=buf[offs+0x10]+(buf[offs+0x11]<<8);
		voice[i].loop_sus=buf[offs+0x12];
		voice[i].loop_end=buf[offs+0x13];
		voice[i].dcp=buf[offs+0x74]|(buf[offs+0x75]<<8);
		voice[i].dcf=buf[offs+0x76];
		voice[i].dcq=buf[offs+0x77];
		voice[i].dca_sus=buf[offs+0x78];
		voice[i].dca_end=buf[offs+0x79];
		voice[i].dcf_sus=buf[offs+0x8a];
		voice[i].dcf_end=buf[offs+0x8b];
		voice[i].lfo_delay=buf[offs+0x9c]|(buf[offs+0x9d]<<8);
		voice[i].lfo_name=buf[offs+0x9e];
		voice[i].lfo_atck=buf[offs+0x9f];
		voice[i].lfo_rate=buf[offs+0xa0];
		voice[i].lfo_dcp=buf[offs+0xa1];
		voice[i].lfo_dca=buf[offs+0xa2];
		voice[i].lfo_dcf=buf[offs+0xa3];
		voice[i].lfo_dcq=buf[offs+0xa4];
		voice[i].vel_dcq_kf=buf[offs+0xa5];
		voice[i].dca_kf=buf[offs+0xa6];
		voice[i].dca_rs=buf[offs+0xa7];
		voice[i].dca_kf=buf[offs+0xa8];
		voice[i].dca_rs=buf[offs+0xa9];
		voice[i].vel_dca_kf=buf[offs+0xaa];
		voice[i].vel_dca_rs=buf[offs+0xab];
		voice[i].vel_dcf_kf=buf[offs+0xac];
		voice[i].vel_dcf_rs=buf[offs+0xad];
		voice[i].vhwid=buf[offs+0xae];
		voice[i].vlwid=buf[offs+0xaf];
		voice[i].vcent=buf[offs+0xb0];
		voice[i].samp=buf[offs+0xb1];
		for(j=0;j<8;j++) {
			offs=i*1024+j*4+bnum*1024;
			voice[i].loopst[j]=buf[offs+0x14]|(buf[offs+0x15]<<8)|(buf[offs+0x16]<<16)|(buf[offs+0x17]<<24);
			voice[i].looped[j]=buf[offs+0x34]|(buf[offs+0x35]<<8)|(buf[offs+0x36]<<16)|(buf[offs+0x37]<<24);
			offs=i*1024+j*2+bnum*1024;
			voice[i].loopxf[j]=buf[offs+0x54]|(buf[offs+0x55]<<8);
			voice[i].looptm[j]=buf[offs+0x64]|(buf[offs+0x65]<<8);
			offs=i*1024+j+bnum*1024;
			voice[i].dca_rate[j]=buf[offs+0x7a];
			voice[i].dca_stop[j]=buf[offs+0x82];
			voice[i].dcf_rate[j]=buf[offs+0x8c];
			voice[i].dcf_stop[j]=buf[offs+0x94];
		}
	}

	printf("\n");
	wmax=0;
		
	/* read bank settings */
	for(i=0;i<bnum;i++) {
		offs=i*1024;
		bank[i].bstep=buf[offs]+(buf[1+offs]<<8);
		strcpy(bank[i].name,buf+offs+0x282);
		printf("Bank %d (%s) \n",1+i,bank[i].name);
		for(j=0;j<bank[i].bstep;j++) {
			offs=i*1024;
			bank[i].bhwid[j]=buf[offs+0x002];
			bank[i].blwid[j]=buf[offs+0x042];
			bank[i].bhtch[j]=buf[offs+0x082];
			bank[i].bltch[j]=buf[offs+0x0c2];
			bank[i].bcent[j]=buf[offs+0x102];
			bank[i].mchn[j]=buf[offs+0x142];
			bank[i].gchn[j]=buf[offs+0x182];
			bank[i].bvol[j]=buf[offs+0x1c2];
			offs=i*1024+j*2;
			bank[i].vp[j]=buf[offs+0x202]|(buf[offs+0x203]<<8);
			printf("\tVoice %d (%s)\n",1+bank[i].vp[j],voice[bank[i].vp[j]].name);
			printf("\t wave start: %8d\n",voice[bank[i].vp[j]].wavst);
			printf("\t wave end:   %8d\n",voice[bank[i].vp[j]].waved);
			if (wmax<voice[bank[i].vp[j]].waved) wmax=voice[bank[i].vp[j]].waved;
			printf("\n");
		}
	}			
	
	if (bnum==0) {
		for(i=0;i<vnum;i++) {
			printf("Voice %d (%s)\n",1+i,voice[i].name);
			printf("\t wave start: %8d\n",voice[i].wavst);
			printf("\t wave end:   %8d\n",voice[i].waved);
			if (wmax<voice[i].waved) wmax=voice[i].waved;

		}
		
		for(i=0;i<strlen(*argv);i++) (*argv)[i]=toupper((*argv)[i]);
		if (strcmp((*argv)+strlen(*argv)-4,".FZF")==0) memset((*argv)+strlen(*argv)-4,0,4);

		outnam=(char *)malloc(strlen(*argv));
		pos=0;
		for(i=0;i<strlen(*argv);i++) {
			if ((*argv)[i]==0x2f) pos=i+1;
			(*argv)[i]=tolower((*argv)[i]);
		}
		strcpy(outnam,&((*argv)[pos]));
		strcpy(*argv,outnam);
		free(outnam);
			                
		printf("\nFile contains only voices.\n");
		printf("\tChanging status to voice dump file.\n");
		printf("\tChanging name to \"%s\".\n",*argv);
		buf[0x3e8+5]=2;
	}

	if (wmax%1024!=0) wmax+=1024;
	wmax=wmax>>10;
	if (wcount!=wmax) {
		printf("\nFile analysis shows\n");
		printf("\tSize of PCM data: %dkB\n",wmax);
		printf("\tOverall size:     %dkB\n",wmax+bcount-wcount);
		printf("\tCorrecting bcount and wcount...\n");

		diff=bcount-wcount;
		buf[0x3e8+12]=wmax&0xff;
		buf[0x3e8+13]=(wmax&0xff00)>>8;

		wmax+=diff;
		buf[0x3e8+10]=wmax&0xff;
		buf[0x3e8+11]=(wmax&0xff00)>>8;

		outnam=(char *)malloc(strlen(*argv)+5);
		pos=0;
		for(i=0;i<strlen(*argv);i++) {
			if ((*argv)[i]==0x2f) pos=i+1;
			(*argv)[i]=tolower((*argv)[i]);
		}
		strcpy(outnam,&((*argv)[pos]));
		if (bnum!=0) strcpy(outnam+strlen(&((*argv)[pos])),".corr");
		fd=fopen(outnam,"w");
		fwrite(buf,1,wmax*1024,fd);
		fclose(fd);
		free(outnam);
	}
}				